/*
hgetblk.c Version 0.1.0  Hash read database block
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void hgetblk(hashfmt *hshhdr, long ofst)
   {
   BOOL  bResult;
   DWORD msgerr;
   LPVOID lpMsgBuf;
   long loc;
   DWORD rdlen;
   hshhdr->reason = 0;
   loc = hseek(hshhdr,ofst);
   if (hshhdr->reason) return;
   bResult = ReadFile(hshhdr->hndl,
      hshhdr->node,
      (DWORD) hshhdr->rcdnode,
      &rdlen,
      NULL);
   if (!bResult)
      {
      msgerr = GetLastError();
      hshhdr->reason = SYS_ERR + msgerr;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,           /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,              /* msglen */
         NULL);          /* insertion values */
      fprintf(stderr,"hgetblk: %s\n", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"hgetblk: error "
         "reading %s\n", hshhdr->dbname);
      fprintf(stderr,"hgetblk: "
	 "ofst %08x rcdnode %d rdlen %d)\n",
	 ofst, hshhdr->rcdnode, rdlen);
      fprintf(stderr,"hgetblk: hndl %d "
         "loc %08x msgerr %d\n",
         hshhdr->hndl, loc, msgerr);
      return;
      } /* read err */
   if (bResult && rdlen == (DWORD) hshhdr->rcdnode)
      {
      hshhdr->ofst = ofst;
      hshhdr->rcd = (unsigned char *)
	 hshhdr->node + hshhdr->rcdhdr;
      return;
      } /* good read */
   else
      {
      fprintf(stderr,"hgetblk: error reading %s\n"
         "hgetblk: ofst %08x rcdnode %d rdlen %d)\n",
         hshhdr->dbname,
         ofst, hshhdr->rcdnode, rdlen);
      hshhdr->reason = HASH_ERR + 1301;
      return;
      } /* read err */
   } /* hgetblk */
