#include <bthash.h>

#define MAXLMT   9999
#define MAXKEYLEN  99
#define RCDHDR      4

void putstx(char *pgm)
   {
   fprintf(stderr,"Usage: %s options\n", pgm);
   fprintf(stderr,"Where options are:\n", pgm);
   fprintf(stderr,"   -k integer for key length\n");
   fprintf(stderr,"   -n integer for number of keys\n");
   fprintf(stderr,"   -h for help\n");
   fprintf(stderr,"Example: %s -k 7 -t 30\n", pgm);
   exit(1);
   } /* putstx */

int main(int argc, char **argv)
   {
   int i;
   int rslt;
   int lmt;
   int keylen;
   long ofst;
   hashfmt *hshhdr;
   unsigned char *rndSeed;
   unsigned char *p,*q;
   unsigned char key[256];
   if (argc >= 1 && argc <= 5);
   else putstx(*argv);
   keylen = 7;
   lmt = 31;
   i = 1;
   while (i < argc)
      {
      rslt = strcmp(*(argv + i),"-k");
      if (!rslt)
         {
         keylen = atoi(*(argv+i+1));
         i += 2;
         continue;
         } /* if keylen */
      rslt = strcmp(*(argv + i),"-t");
      if (!rslt)
         {
         lmt = atoi(*(argv+i+1));
         i += 2;
         continue;
         } /* if lmt */
      rslt = strcmp(*(argv + i),"-h");
      if (!rslt)
         {
         putstx(*argv);
         i += 2;      
         continue;
         } /* if lmt */
      fprintf(stderr,"tsthash: invalid parameter %s\n",
         *(argv+i));
      exit(1);
      } /* for each pair of arguments */
   if (lmt < 1 || lmt > MAXLMT)
      {
      fprintf(stderr,"tsthash: invalid number of keys\n");
      putstx(*argv);
      } /* if invalid lmt */
   if (keylen < 1 || keylen > MAXKEYLEN)
      {
      fprintf(stderr,"tsthash: invalid key length\n");
      putstx(*argv);
      } /* if invalid keylen */
   rndSeed = (unsigned char *) rndinit();
   if (rndSeed == NULL)
      {
      fprintf(stderr,"tsthash: rndinit failed\n");
      exit(1);
      } /* if rndinit failed */
   hshhdr = (hashfmt *) malloc(HDRLEN+HDRLEN);
   if (hshhdr == NULL)
      {
      fprintf(stderr,"tsthash: out of memory\n");
      exit(1);
      } /* if malloc failed */
   hshhdr->rcdhdr  = RCDHDR;
   hshhdr->totrcds = lmt;
   hshhdr->rcdlen  = keylen;
   hshhdr->keylen  = keylen;
   hshhdr->keyofst = 0;
   hshhdr->rcdnode = hshhdr->rcdhdr + hshhdr->rcdlen;
   p = (unsigned char *) key;
   q = (unsigned char *) p + hshhdr->keylen;
   while (p < q) *p++ = 'A';
   *p = '\0';
   i = lmt;
   while (i--)
      {
      ofst = hash(hshhdr,key);
      printf("%5d.  %08x  %s\n",
         lmt - i, ofst, key);
      p = (unsigned char *) key + hshhdr->keylen - 1;
      q = (unsigned char *) key;
      while (p >= q)
         {
         (*p)++;
         if (*p <= 'Z') break;
         *p = 'A';
         p--;
         } /* right to left */
      } /* for each key to hash */
   return(0);
   } /* main */
